
                       /*** Machine-specific defines ***/

#ifndef __MSDOS__
#define far 
#define farmalloc  malloc
#endif

#define ROUND      1e-12   /* conservative rounding error estimate */
#define GREEN      2       /* colours */
#define GREY       7



#define MININT 5e-5     /* forget transitions weaker than this */
#define ACC    1e-9  /* accuracy parameter. seek this fraction of smallest j */
#define MAX    7        /* maximum spins */
#define P2MAX  128      /* 2**MAX */
#define MAXBLK 35       /* largest binomial coefficient of order MAX */


struct transition {  double de;
                     double intens;
                  };

struct screendef  {    int xpels;
                       int ypels;
                       int crows;
                       int ccols;
                  };


void hardinit(void) ;
void hardfinish(void);
void getscreen(struct screendef *s);
void cls(void);
void clrinp(void);
void cursor(int row, int col);
void prnc(char *s);
int  key(void);
void statmsg(char *f, char *s);
void errmsg(char *f, char *s);
void zzstr(char *s, int n);
double getparm(char *prompt);
double rnh(double x);
double rnl(double x);
void nmrcalc( int nspin, double *freq, double j[MAX][MAX],
     struct transition far *t);
int bitcount(int i, int n);
int ymeig(int n, double *a, double *e, double eps, int v);
void tssort(struct transition far *data, int n);
void stickplot(struct transition far *data, double left, double right,
                     int nt, int hp);
void lorentzplot(struct transition far *data, double left, double right,
                     int nt, int hp, double fwhm);
void hpout(char *s);
void hpinit(void);
int axis(double left, double right, int hp);
void line (int x1, int y1, int x2, int y2, unsigned char colour);
void screendump (int dotrows, char *filename);
int squob(char *s);
